--EXPLAIN (ANALYZE, BUFFERS)
WITH 
pc AS materialized (
    SELECT
         STLC 
        ,COALESCE(COLTIER,'') COLTIER 
        ,coalesce(BRANDING,'' ) branding
        ,COALESCE(ACCS ,'') ACCS
        ,COALESCE(SUFF,'') SUFFIX
        ----price 1 -----------------
        ,PCKG PCKG1
        ,1 VOLL1
        ,PCKG VOL1_UOM
        ,PACK VOL1_PRICE
        ----price 2 -----------------
        ,PCKG PCKG2
        ,1 VOLl2
        ,'PLT' VOL2_UOM
        ,MP VOL2_PRICE
        ----price 3 -----------------
        ,'PLT' PCKG3
        ,1 VOLL3
        ,'PLT' VOL3_UOM
        ,BULK VOL3_PRICE
    FROM
        rlarp.PCORE P
)
,colors AS (
SELECT
     pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
    ,string_agg( DISTINCT ltrim(rtrim(i.COLC)),', ') tclist
    ,jsonb_agg( DISTINCT ltrim(rtrim(i.COLC))) clist
    ------price 1 -----------------
    --,pc.PCKG1
    --,pc.VOLL1
    --,pc.VOL1_UOM
    --,pc.VOL1_PRICE
    ------price 2 -----------------
    --,pc.PCKG2
    --,pc.VOLl2
    --,pc.VOL2_UOM
    --,pc.VOL2_PRICE
    ------price 3 -----------------
    --,pc.PCKG1
    --,pc.VOLL3
    --,pc.VOL3_UOM
    --,pc.VOL3_PRICE
FROM    
    pc
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = pc.stlc
        AND i.COLTIER = pc.coltier
        --relax relationship to pick up any colors that we run for the mold and color tier
        --AND COALESCE(i.BRANDING,'') = pc.branding
        --AND COALESCE(i.ACCS,'') = pc.ACCS
        --AND COALESCE(i.SUFFIX,'') = pc.suffix
        AND APLNT <> 'I'
GROUP BY 
     pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
    ----price 1 -----------------
    ,pc.PCKG1
    ,pc.VOLL1
    ,pc.VOL1_UOM
    ,pc.VOL1_PRICE
    ----price 2 -----------------
    ,pc.PCKG2
    ,pc.VOLl2
    ,pc.VOL2_UOM
    ,pc.VOL2_PRICE
    ----price 3 -----------------
    ,pc.PCKG1
    ,pc.VOLL3
    ,pc.VOL3_UOM
    ,pc.VOL3_PRICE
)
-----------since joining to the item master will be differnt for the last bulk columm---------------
-----------must first pivot the data out then join based on the type of row-------------------------
,unpivot AS (
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,1 col
        ,pc.pckg1 pckg
        ,pc.vol1_uom vol_uom
        ,pc.voll1 vol_qty
        ,pc.vol1_price price
    FROM
        pc
    UNION
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,2 col
        ,pc.pckg2 pckg
        ,pc.vol2_uom vol_uom
        ,pc.voll2 vol_qty
        ,pc.vol2_price price
    FROM
        pc
    UNION
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,3 col
        ,pc.pckg3 pckg
        ,pc.vol3_uom vol_uom
        ,pc.voll3 vol_qty
        ,pc.vol3_price price
    FROM
        pc
)
----link to actual part numbers, tag the sequence so a single item can be chosen-----
,items_init AS (
SELECT 
     up.STLC
    ,up.coltier
    ,up.branding
    ,up.accs
    ,up.suffix
    ,up.pckg
    --retain this column to re-pivot back to original format
    ,up.col
    ,up.vol_uom
    ,up.voL_qty
    ,up.price
    ,row_number() OVER (PARTITION BY up.stlc, up.coltier, up.branding, up.accs, up.suffix, up.pckg, up.col, up.vol_uom ORDER BY item DESC) seq
    ,item
    --subquery option is not performant at all
    --,(
    --    SELECT 
    --        item 
    --    FROM 
    --        rlarp.itemmv v 
    --    WHERE 
    --        v.stlc = up.stlc 
    --        AND v.branding = up.branding 
    --        AND v.accs = up.accs 
    --        AND v.suffix = up.suffix
    --        AND v.uomp ? up.pckg
    --        AND v.aplnt <> 'I'
    --    LIMIT 1
    --) item_subq
FROM    
    unpivot up
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = up.stlc
        --AND i.COLTIER = pc.coltier
        AND i.uomp ? up.pckg
        AND COALESCE(i.BRANDING,'') = up.branding
        AND COALESCE(i.ACCS,'') = up.ACCS
        AND COALESCE(i.SUFFIX,'') = up.suffix
        AND APLNT <> 'I'
)
----compile all the conversions into a single json object----------------------
,items AS (
    SELECT
        jsonb_agg( DISTINCT 
            jsonb_build_object(
                'partn', item
                ,'fu', vol_uom
                ,'tu','PC'
            )
        ) conv
    FROM 
        items_init 
    WHERE 
        seq = 1
        AND COALESCE(item,'') <> ''
)
--do the conversion-------------------------------------------------------------
, conversion AS (
    SELECT
        rslt.* 
    FROM
        items 
        JOIN LATERAL rlarp.uom_array(conv) rslt ON true
)
--missing column 3
--SELECT * FROM unpivot ORDER BY stlc
--SELECT * FROM items_init where seq = 1
--SELECT * FROM items where seq = 1
----join conversion back to data initial part link------------------------------
,joinback_init AS (
SELECT 
    i.stlc
    ,i.coltier
    ,i.branding
    ,i.accs
    ,i.suffix
    ,i.pckg
    ,i.col
    ,i.vol_uom
    ,i.vol_qty
    ,i.price
    ,c.nm
    ,c.dm
    ,l.clist
FROM
    items_init i
    LEFT OUTER JOIN conversion c ON
        c.p = i.item
        AND c.f = i.vol_uom
    NATURAL JOIN colors l
WHERE
    i.seq = 1
ORDER BY
     i.stlc
    ,i.coltier
    ,i.col
)
,agg_levels AS (
    SELECT
         stlc
        ,string_agg(DISTINCT coltier ,', ') FILTER (WHERE clist IS NOT NULL) coltier
        ,string_agg(DISTINCT branding,', ') branding
        ,string_agg(DISTINCT accs    ,', ') accs
        ,string_agg(DISTINCT suffix  ,', ') suffix
        ,pckg
        ,col
        ,vol_uom
        ,voL_qty
        ,price
        ,regexp_replace(jsonb_arr_aggcd(clist)::text,'["\[\]]|null, ','','g') clist
    FROM
        joinback_init
    GROUP BY
        stlc
        ,pckg
        ,col
        ,vol_uom
        ,vol_qty
        ,price
)
SELECT 
    * 
FROM 
    agg_levels
